Subject: Re: [PATCH] bpf: validate bpf_func when BPF_JIT is enabled

From: Toke Høiland-Jørgensen <[email-masked]>
Date: Thu, 12 Sep 2019 11:46:39 +0100

Sami Tolvanen <[email-masked]> writes:

> On Wed, Sep 11, 2019 at 5:09 AM Toke Høiland-Jørgensen <[email-masked]> wrote:
>>
>> Björn Töpel <[email-masked]> writes:
>> > I ran the "xdp_rxq_info" sample with and without Sami's patch:
>>
>> Thanks for doing this!
>
> Yes, thanks for testing this Björn!
>
>> Or (1/22998700 - 1/23923874) * 10**9 == 1.7 nanoseconds of overhead.
>>
>> I guess that is not *too* bad; but it's still chipping away at
>> performance; anything we could do to lower the overhead?
>
> The check is already rather minimal, but I could move this to a static
> inline function to help ensure the compiler doesn't generate an
> additional function call for this. I'm also fine with gating this
> behind a separate config option, but I'm not sure if that's worth it.
> Any thoughts?

I think it would be good if you do both. I'm a bit worried that XDP
performance will end up in a "death by a thousand paper cuts" situation,
so I'd rather push back on even relatively small overheads like this; so
being able to turn it off in the config would be good.

Can you share more details about what the "future CFI checking" is
likely to look like?

-Toke